-- 
-- 3. Übung - Bereinigung der Daten
-- 
-- ST_IsValidDetail ST_IsValidReason
-- ST_MakeValid
-- ST_RemoveRepeatedPoints

----------------------------------------------------------------------
-- Erläuterung


#  Aufruf auf der Konsole
-- Aufruf als SQL 
----------------------------------------------------------------------


Drop table invalid_polygons;
CREATE TABLE invalid_polygons(
gid serial,
invalid_reason varchar,
the_geom geometry(Polygon,4326)
);


----------------------------------------------------------------------
-- 3.1 Erzeugen Sie ein paar ungültige Geometrien
----------------------------------------------------------------------

-- self-intersection
INSERT INTO invalid_polygons VALUES (1, '',
ST_GeomFromText('POLYGON((0 0, 0 1, 1 1, 1.5 1, 1.5 1.5, 1 1.5, 1 0, 0 0))',4326));

-- self-intersection
INSERT INTO invalid_polygons VALUES (2, '',
ST_GeomFromText('POLYGON((0 0, 0 1, 1 1, 1 2, 1 0, 0 0))',4326));

-- self-intersection - dreieck
INSERT INTO invalid_polygons VALUES (3, '',
ST_GeomFromText('POLYGON((0 0, 0 1, 1 1, 1 0, 0 0),(0.25 1, 0.75 1, 0.5 0.75,0.25 1))',4326));

-- self-intersection - dreieck
INSERT INTO invalid_polygons VALUES (4, '',
ST_GeomFromText('POLYGON((0 0, 0 1, 0.25 1,  0.5 0.75, 0.75 1, 1 1, 1 0, 0 0),
(0.25 1, 0.5 1.25, 0.75 1,0.25 1))',4326));

-- Fläche ohne Flächeninhalt
INSERT INTO invalid_polygons VALUES (5, '',ST_GeomFromText('POLYGON((0 0, 0 0, 1 0, 1 0, 0 0))',4326));

-- repeated points
INSERT INTO invalid_polygons VALUES (6, '',ST_GeomFromText('POLYGON((0 0, 0 1, 1 1, 1 1,1 0, 0 0))',4326));

Update invalid_polygons SET the_geom = st_translate(the_geom,gid,0)   where gid = 2;
Update invalid_polygons SET the_geom = st_translate(the_geom,gid+1,0) where gid = 3;
Update invalid_polygons SET the_geom = st_translate(the_geom,gid+2,0) where gid = 4;
Update invalid_polygons SET the_geom = st_translate(the_geom,gid+3,0) where gid = 5;
Update invalid_polygons SET the_geom = st_translate(the_geom,gid+4,0) where gid = 6;


----------------------------------------------------------------------
-- 3.2 Prüfen Sie Ihre Geometrien: 
-- * sind die Flächen gültig?
-- * warum sind einige Geometrien ungültig?
-- * wie groß ist die Fläche der Polygone?
----------------------------------------------------------------------
UPDATE invalid_polygons SET invalid_reason = ST_IsValidReason(the_geom);

ALTER TABLE invalid_polygons add column valid boolean;
UPDATE invalid_polygons SET valid = ST_IsValid(the_geom);

ALTER TABLE invalid_polygons add column area float8;
UPDATE invalid_polygons SET area = ST_area(the_geom);

select ST_Area(the_geom), st_isvalidreason(the_geom), st_isvaliddetail(the_geom) from invalid_polygons;


----------------------------------------------------------------------
-- 3.3 Bereinigung der Daten
----------------------------------------------------------------------

--Drop Table valid_polygons;
Create Table valid_polygons as
SELECT gid, 
ST_Isvalidreason(ST_MakeValid(the_geom)),
ST_MakeValid(the_geom) as the_geom , 
ST_Area(ST_MakeValid(the_geom)) as area
from invalid_polygons;

Select *, ST_AsText(the_geom) from valid_polygons; 

Drop Table valid_polygons_dump;
Create table valid_polygons_dump as 
SELECT (result).path[1] as gid, (result).geom as the_geom, ST_Area((result).geom) as area from (
SELECT st_dump(the_geom) as result 
from valid_polygons where gid = 2 or gid = 3) as foo; 


select st_AsText(the_geom), st_area(the_geom) from invalid_polygons ;
                     st_astext                      | st_area 
----------------------------------------------------+---------
 POLYGON((0 0,0 1,1 1,1.5 1,1.5 1.5,1 1.5,1 0,0 0)) |    0.75
 POLYGON((0 0,0 1,1 1,1 1,1 0,0 0))                 |       1
(2 Zeilen)

SELECT st_isvalidreason(the_geom) AS reason, 
st_isvaliddetail(the_geom) AS detail ,
ST_Area(the_geom) AS area
FROM invalid_polygons;
                  reason                   |                      detail      |  area  
-------------------------------------------+--------------------------------------------------------

 Self-intersection[1 1]                    | (f,Self-intersection,0101000000000000000000F03F00000000
0000F03F)                      |   0.75
 Self-intersection[3 1]                    | (f,Self-intersection,0101000000000000000000084000000000
0000F03F)                      |      1
 Self-intersection[4.25 1]                 | (f,Self-intersection,0101000000000000000000114000000000
0000F03F)                      | 0.9375
 Self-intersection[6.25 1]                 | (f,Self-intersection,0101000000000000000000194000000000
0000F03F)                      |  0.875
 Too few points in geometry component[8 0] | (f,"Too few points in geometry component",0101000000000
00000000020400000000000000000) |      0
 Valid Geometry                            | (t,,)                                                  
                               |      1
(6 Zeilen)




Create table valid_polygons as SELECT gid,
 st_isvalidreason(st_makevalid(the_geom)),
st_makevalid(the_geom) as the_geom from invalid_polygons;


----------------------------------------------------------------------
-- 3.4 ST_RemoveRepeatedPoints
-- Entfernen von doppelten Punkten
----------------------------------------------------------------------

SELECT ST_NumPoints(ST_ExteriorRing(ST_GeometryN(the_geom,1))) AS vorher, 
ST_NumPoints(ST_ExteriorRing(ST_GeometryN(ST_RemoveRepeatedPoints(the_geom),1)) AS nachher
FROM invalid_polygons WHERE gid = 6;
 vorher	   |  nachher
-----------+---------
       6   |       5

SELECT ST_AsText(the_geom) old, ST_AsText(ST_RemoveRepeatedPoints(the_geom)) as new from invalid_polygons where gid=6;
                   old                    |                 new                 
------------------------------------------+-------------------------------------
 POLYGON((10 0,10 1,11 1,11 1,11 0,10 0)) | POLYGON((10 0,10 1,11 1,11 0,10 0))
(1 Zeile)


Update invalid_polygons set 
the_geom = ST_RemoveRepeatedPoints(the_geom);


