-- 
-- 4. Übung Raster
-- 
--
----------------------------------------------------------------------
-- Erläuterung


#  Aufruf auf der Konsole
-- Aufruf als SQL 
----------------------------------------------------------------------

----------------------------------------------------------------------
-- 4.1. Importieren Sie die Rasterdatei germany.tif mit Hilfe von raster2pgsql
-- setzen Sie die Optionen -s 4326 -t 100x100 (Kacheln) und -l (Bildung von Übersichen)
----------------------------------------------------------------------
# Ausgabe der unterstützten Formate
raster2pgsql -G

Available GDAL raster formats:
  Virtual Raster
  GeoTIFF
  National Imagery Transmission Format
  Raster Product Format TOC format
  ECRG TOC format
  Erdas Imagine Images (.img)
  ....


# Datenimport mit raster2pgsql
raster2pgsql -s 4326 -I -C -M -F /home/user/workshop/germany/germany.tif germany | psql -U user -p 5432 -d fossgis
raster2pgsql -s 4326 -I -C -M -F -l 4 /home/user/workshop/germany/germany.tif germanyl | psql -U user -p 5432 -d fossgis
raster2pgsql -s 4326 -I -C -M -F -l 4 -t 100x100 /home/user/workshop/germany/germany.tif germanyt | psql -U user -p 5432 -d fossgis
-C - legt Constraints an
-M - führt nach Import VACUUM ANALYZE durch
-F - legt zusätzliche Spalte für den Dateinamen an
-l - bildet Übersichten
-t - Angabe der gewünschten Kachelgröße
-s - EPSG-Code
-I - Indizierung


----------------------------------------------------------------------
-- 4.2. Schauen Sie sich den Aufbau der Tabellen und die Inhalte an
----------------------------------------------------------------------
-- Ausgabe des Tabellenaufbaus der Tabelle germany
\d germany
                            Tabelle »public.germany«
  Spalte  |   Typ   |                         Attribute                         
----------+---------+-----------------------------------------------------------
 rid      | integer | not null Vorgabewert nextval('germany_rid_seq'::regclass)
 rast     | raster  | 
 filename | text    | 
Indexe:
    "germany_pkey" PRIMARY KEY, btree (rid)
    "germany_rast_gist" gist (st_convexhull(rast))
Check-Constraints:
    "enforce_height_rast" CHECK (st_height(rast) = 540)
    "enforce_max_extent_rast" CHECK (st_coveredby(st_convexhull(rast), '01030000208C1000000100000005000000EFF83793000014408401B9F5FF7F4740EFF83793000014403301A9F9FFFF4B400FFB1B5B00002E403301A9F9FFFF4B400FFB1B5B00002E408401B9F5FF7F4740EFF83793000014408401B9F5FF7F4740'::geometry))
    "enforce_nodata_values_rast" CHECK (_raster_constraint_nodata_values(rast)::numeric(16,10)[] = '{NULL,NULL,NULL}'::numeric(16,10)[])
    "enforce_num_bands_rast" CHECK (st_numbands(rast) = 3)
    "enforce_out_db_rast" CHECK (_raster_constraint_out_db(rast) = '{f,f,f}'::boolean[])
    "enforce_pixel_types_rast" CHECK (_raster_constraint_pixel_types(rast) = '{8BUI,8BUI,8BUI}'::text[])
    "enforce_same_alignment_rast" CHECK (st_samealignment(rast, '0100000000CCFEFF1F1111913FCCFEFF1F111191BFEFF83793000014403301A9F9FFFF4B40000000000000000000000000000000008C10000001000100'::raster))
    "enforce_scalex_rast" CHECK (st_scalex(rast)::numeric(16,10) = 0.0166666675359::numeric(16,10))
    "enforce_scaley_rast" CHECK (st_scaley(rast)::numeric(16,10) = (-0.0166666675359)::numeric(16,10))
    "enforce_srid_rast" CHECK (st_srid(rast) = 4326)
    "enforce_width_rast" CHECK (st_width(rast) = 600)


-- Wieviele Kacheln wurden angelegt in germanyt
Select count(*) from germanyt;
 count 
-------
    72


----------------------------------------------------------------------
-- 4.3. Schauen Sie sich die Kataloginformationen in den 
-- Sichten raster_columns und raster_overviews an
----------------------------------------------------------------------

-- raster_columns
SELECT * FROM raster_columns;
-[ RECORD 1 ]-
r_table_catalog  | fossgis
r_table_schema   | public
r_table_name     | germany
r_raster_column  | rast
srid             | 4326
scale_x          | 0.0166666675359
scale_y          | -0.0166666675359
blocksize_x      | 600
blocksize_y      | 540
same_alignment   | t
regular_blocking | f
num_bands        | 3
pixel_types      | {8BUI,8BUI,8BUI}
nodata_values    | {NULL,NULL,NULL}
out_db           | {f,f,f}
extent           | 01030000208C1000000100000005000000EFF83793000014408401B9F5FF7F4740EFF837930000144
03301A9F9FFFF4B400FFB1B5B00002E403301A9F9FFFF4B400FFB1B5B00002E408401B9F5FF7F4740EFF8379300001440840
1B9F5FF7F4740
....


-- raster_overviews
SELECT * FROM raster_overviews;
-[ RECORD 1 ]---+-------------
o_table_catalog | fossgis
o_table_schema  | public
o_table_name    | o_4_germanyl
o_raster_column | rast
r_table_catalog | fossgis
r_table_schema  | public
r_table_name    | germanyl
r_raster_column | rast
overview_factor | 4


----------------------------------------------------------------------
-- 4.3. Importieren Sie das die Shapes countries_pl
-- Laden Sie die Tabellen in QGIS
----------------------------------------------------------------------

# Import über shp2pgsql
shp2pgsql -W LATIN1 -I -s 4326 -g the_geom /home/user/workshop/germany/countries_pl.shp laender | psql -U user -p 5432 fossgis


----------------------------------------------------------------------
-- 4.4. ST_Polygon - überführen Sie die ersten 6 Kacheln in Polygone 
-- und setzen Sie dabei ST_SetBandNoDataValue - Band 1 Rotwert 87
-- Schauen Sie sich das Ergebnis in QGIS an
----------------------------------------------------------------------

ALTER TABLE germanyt DROP constraint enforce_nodata_values_rast;
UPDATE germanyt SET rast = ST_SetBandNoDataValue(rast,1,87) WHERE rid < 6;
CREATE TABLE germany_polygon as Select ST_Polygon(rast) FROM germanyt WHERE rid < 6;




----------------------------------------------------------------------
-- 4.5. Ausgabe von Informationen zu den Rasterdaten
-- * ST_Height, ST_Width
-- * ST_PixelHeight
-- * ST_NumBands
-- * ST_MetaData(rast) - Ausgabe von Metadaten
----------------------------------------------------------------------

SELECT rid, 
ST_Height(rast), 
ST_Width(rast),
ST_PixelHeight(rast),
ST_NumBands(rast)
FROM germany;

SELECT rid, (foo.md).*  
 FROM (SELECT rid, ST_MetaData(rast) As md
FROM germany) As foo;

----------------------------------------------------------------------
-- 4.7 Laden Sie die Daten aus der Datenbank in QGIS
-- Aktivieren Sie das Plugin Load PostGIS Raster to QGIS
-- Menü: Datenbank - PostGIS Raster -> add a PostGIS Ratser Layer
----------------------------------------------------------------------


